<?xml version="1.0" encoding="UTF-8"?>
<sch:schema xmlns:sch="http://www.ascc.net/xml/schematron">
   <sch:title>Schematron Validator for Staff Assignments</sch:title>
   <sch:pattern name="abstracts">
      <sch:rule abstract="true" id="check-code">
         <sch:assert test="@code">
            <sch:name/>must have a code attribute.</sch:assert>
      </sch:rule>
   </sch:pattern>
   <sch:pattern name="groups">
      <sch:rule context="group">
         <sch:key name="group-key" path="@code"/>
         <sch:extends rule="check-code"/>
      </sch:rule>
   </sch:pattern>
   <sch:pattern name="projects">
      <sch:rule context="project">
         <sch:key name="project-key" path="@code"/>
         <sch:extends rule="check-code"/>
      </sch:rule>
   </sch:pattern>
   <sch:pattern name="assignments">
      <sch:rule context="staff">
         <sch:extends rule="check-code"/>
         <sch:assert test="key('group-key', @group)">
            <sch:name/>does not have a valid group code.</sch:assert>
         <sch:assert test="key('project-key', @project)">
            <sch:name/>does not have a valid project code.</sch:assert>
      </sch:rule>
   </sch:pattern>
</sch:schema>