<?xml version="1.0" encoding="UTF-8"?>
<x:stylesheet xmlns:x="http://www.w3.org/1999/XSL/Transform" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:eg="http://examplotron.org/0/" xmlns:saxon="http://icl.com/saxon" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:ns1="http://www.w3.org/XML/1998/namespace" version="1.0" ns1:dummy="">
   <x:template match="*">
      <error type="Unexpected element">
         <x:attribute name="path">
            <x:call-template name="getPath"/>
         </x:attribute>
      </error>
   </x:template>
   <x:template match="@*">
      <error type="Unexpected attribute">
         <x:attribute name="path">
            <x:call-template name="getAttPath"/>
         </x:attribute>
      </error>
   </x:template>
   <x:template name="getPath">
      <x:for-each select="parent::*">
         <x:call-template name="getPath"/>
      </x:for-each>
      <x:variable name="name" select="name()"/>
      <x:value-of select="concat('/', $name, '[', count(preceding-sibling::*[name()=$name])+1, ']')"/>
   </x:template>
   <x:template name="getAttPath">
      <x:for-each select="parent::*">
         <x:call-template name="getPath"/>
      </x:for-each>
      <x:variable name="name" select="name()"/>
      <x:value-of select="concat('/@', $name)"/>
   </x:template>
   <x:template priority="1" match="/">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse">
      <error type="Element content mismatch" name="/loanResponse" expected="[count(partnerID)=1 and count(transactionID)=1 and count(loanAmount)=1 and count(partnerOutlet)=1 and count(goods)=1 and count(loanType)=1 and count(decision)=1 and count(decisionID)=1 and  1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse[count(partnerID)=1 and count(transactionID)=1 and count(loanAmount)=1 and count(partnerOutlet)=1 and count(goods)=1 and count(loanType)=1 and count(decision)=1 and count(decisionID)=1 and  1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse/partnerID">
      <error type="Element content mismatch" name="/loanResponse/partnerID" expected="[ 1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/partnerID[ 1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse/transactionID">
      <error type="Element content mismatch" name="/loanResponse/transactionID" expected="[ 1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/transactionID[ 1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse/loanAmount">
      <error type="Element content mismatch" name="/loanResponse/loanAmount" expected="[ 1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/loanAmount[ 1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse/partnerOutlet">
      <error type="Element content mismatch" name="/loanResponse/partnerOutlet" expected="[ 1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/partnerOutlet[ 1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse/goods">
      <error type="Element content mismatch" name="/loanResponse/goods" expected="[count(item)=1 and  1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/goods[count(item)=1 and  1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse/goods/item">
      <error type="Element content mismatch" name="/loanResponse/goods/item" expected="[@partNo and @price and @quantity and @value and  1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/goods/item[@partNo and @price and @quantity and @value and  1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/goods/item/@partNo"/>
   <x:template priority="1" match="/loanResponse/goods/item/@price"/>
   <x:template priority="1" match="/loanResponse/goods/item/@quantity"/>
   <x:template priority="1" match="/loanResponse/goods/item/@value"/>
   <x:template match="/loanResponse/loanType">
      <error type="Element content mismatch" name="/loanResponse/loanType" expected="[ 1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/loanType[ 1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse/decision">
      <error type="Element content mismatch" name="/loanResponse/decision" expected="[ 1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/decision[ 1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
   <x:template match="/loanResponse/decisionID">
      <error type="Element content mismatch" name="/loanResponse/decisionID" expected="[ 1=1]"/>
   </x:template>
   <x:template priority="1" match="/loanResponse/decisionID[ 1=1]">
      <x:apply-templates select="*|@*"/>
   </x:template>
</x:stylesheet>