// This file is:  msxsd-sch.js
// first parameter is an XML files to be read in;
// second parameter is the schema file
// third parameter is an optional schematron validator

// validate parameters
if((WScript.Arguments.length < 2) || (WScript.Arguments.length > 3))
{
	WScript.Echo("msxsd-sch takes two or three arguments - datafile, schema, (optional) xsltValidator - eg:");
	WScript.Echo('msxsd books.xml books.xsd books.xslt');
	WScript.Echo('msxsd books.xml books.xsd');
}
else if(WScript.Arguments.length == 3)
{
	validate(WScript.Arguments(0), WScript.Arguments(1), WScript.Arguments(2));
}
else
{
	validate(WScript.Arguments(0), WScript.Arguments(1), "");
}

function validate(datafile, schema, validator)
{
	// load the schema
	var xsdDoc = loadXML(schema);
	
	// find the targetNamespace
	xsdDoc.setProperty("SelectionLanguage", "XPath");
	xsdDoc.setProperty("SelectionNamespaces", "xmlns:xsd='http://www.w3.org/2001/XMLSchema'");
	var ns = xsdDoc.selectSingleNode("/xsd:schema/@targetNamespace");
	
	// add the schema to the cache with the target namespace
	var cache = new ActiveXObject("Msxml2.XMLSchemaCache.4.0");
	if (ns == null)
	{
		cache.add('', xsdDoc);
	}
	else
	{
		cache.add(ns.text, xsdDoc);
	}
	
	// load the data file and validate against the schema
	var xmlDoc = loadXML(datafile, cache);
		
	// load validator if specified
	if(validator != "")
	{
		var xslDoc = loadXML(validator);	
		WScript.Echo(xmlDoc.transformNode(xslDoc));
	}
}

function loadXML(source, schemaCache)
{
	var xmlDoc  = new ActiveXObject("Msxml2.DOMDocument.4.0");
	xmlDoc.async = false;
	if (schemaCache != undefined)
	{
		xmlDoc.schemas = schemaCache;
	}
	xmlDoc.load(source);
	if(xmlDoc.parseError.errorCode != 0)
	{
		loadError(source, xmlDoc);
		WScript.Quit(1);
	}
	return xmlDoc;
}

function loadError(source, xmlDoc)
{
	WScript.Echo("Error loading " + source);
	WScript.Echo("Code: " + xmlDoc.parseError.errorCode);
	WScript.Echo("Source: " + xmlDoc.parseError.srcText);
	WScript.Echo("Line: " + xmlDoc.parseError.line);
	WScript.Echo("Error: " + xmlDoc.parseError.reason);
}