<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://www.ascc.net/xml/schematron">
	<title>Schematron Validator for Purchase Orders</title>
	<phase id="received">
		<active pattern="root">Check for correct root element</active>
	</phase>
	<phase id="processed">
		<active pattern="shipAndPrice">Ordered items must have match prices to shipment country.</active>
		<active pattern="stock">Ordered items have stock numbers.</active>
	</phase>
	<pattern name="Top Level Purchase Order elements" id="root">
		<rule context="/*">
			<assert test="self::purchaseOrder">The root element must be a "purchaseOrder"</assert>
		</rule>
	</pattern>
	<pattern name="Shipping and Price" id="shipAndPrice">
		<rule context="USPrice">
			<assert test="/purchaseOrder/shipTo/@country='US'" diagnostics="actualCountry"
			><name /> may only be charged for US delivery</assert>
		</rule>
		<rule context="ExportPrice">
			<assert test="/purchaseOrder/shipTo/@country != 'US'"><name /> may not be charged for US delivery</assert>
		</rule>
	</pattern>
	<pattern name="Processed by Stock Control" id="stock">
		<rule context="item">
			<assert test="@partNum != ''"><name/> must have a non-null partNum</assert>
		</rule>
	</pattern>
	<diagnostics>
		<diagnostic id="actualCountry"
		>Actual shipTo country was <value-of select="/purchaseOrder/shipTo/@country"/></diagnostic>
	</diagnostics>
</schema>
