<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://www.ascc.net/xml/schematron">
   <title>Schematron Validator for Purchase Orders</title>
   <pattern name="abstracts">
      <rule abstract="true" id="childLess">
         <assert test="count(*) = 0">
         <name/>must not have any child elements</assert>
      </rule>
   </pattern>
   <pattern name="Top Level Purchase Order elements" id="root">
      <rule context="/*">
         <assert test="self::purchaseOrder"
         >The root element must be a "purchaseOrder"</assert>
      </rule>
   </pattern>
   <pattern name="Shipping and Price" id="shipAndPrice">
      <rule context="USPrice">
         <extends rule="childLess"/>
         <assert test="/purchaseOrder/shipTo/@country = 'US'">
         <name />may only be charged for US delivery</assert>
      </rule>
      <rule context="ExportPrice">
         <extends rule="childLess"/>
         <assert test="/purchaseOrder/shipTo/@country != 'US'">
         <name />may not be charged for US delivery</assert>
      </rule>
   </pattern>
   <pattern name="Processed by Stock Control" id="stock">
      <rule context="item">
         <assert test="@partNum != ''">
         <name/>must have a non-null partNum</assert>
      </rule>
   </pattern>
</schema>